var NAVTREE =
[
  [ "GNU Radio 3.7.3 C++ API", "index.html", [
    [ "Building GNU Radio", "index.html#build", null ],
    [ "GNU Radio Blocks", "index.html#blocks", null ],
    [ "Manual Contents", "index.html#toc", null ],
    [ "Operating a Flowgraph", "index.html#flowgraph", [
      [ "Latency and Throughput", "index.html#latency", null ]
    ] ],
    [ "Reconfiguring Flowgraphs", "index.html#reconfigure", null ],
    [ "Using Volk in GNU Radio", "index.html#volk_main", null ],
    [ "Configuration / Preference Files", "index.html#prefs", null ],
    [ "Out-of-Tree Configuration", "index.html#oot_config_page", [
      [ "Install Path", "index.html#oot_config_path_page", null ]
    ] ],
    [ "ControlPort", "page_ctrlport.html", [
      [ "Introduction", "page_ctrlport.html#Introduction", null ],
      [ "Dependencies", "page_ctrlport.html#Dependencies", null ],
      [ "Configuration", "page_ctrlport.html#conf", null ],
      [ "Using ControlPort to Export Variables", "page_ctrlport.html#using_ctrlport", [
        [ "Alternative Registers", "page_ctrlport.html#alt_reg", null ]
      ] ],
      [ "Display Options", "page_ctrlport.html#disp", null ],
      [ "ControlPort Probes", "page_ctrlport.html#probes", null ],
      [ "ControlPort Monitors", "page_ctrlport.html#monitors", [
        [ "Performance Monitor", "page_ctrlport.html#perfmonitor", null ]
      ] ]
    ] ],
    [ "Build Instructions and Information", "build_guide.html", [
      [ "Dependencies", "build_guide.html#dependencies", [
        [ "Global Dependencies", "build_guide.html#dep_global", null ],
        [ "Python Wrappers", "build_guide.html#dep_python", null ],
        [ "docs: Building the documentation", "build_guide.html#dep_docs", null ],
        [ "grc: The GNU Radio Companion", "build_guide.html#dep_grc", null ],
        [ "gr-wavelet: Collection of wavelet blocks", "build_guide.html#dep_wavelet", null ],
        [ "gr-qtgui: The QT-based Graphical User Interface", "build_guide.html#dep_gr_qtgui", null ],
        [ "gr-wxgui: The WX-based Graphical User Interface", "build_guide.html#dep_gr_wxgui", null ],
        [ "gr-audio: Audio Subsystems (system/OS dependent)", "build_guide.html#dep_gr_audio", null ],
        [ "uhd: The Ettus USRP Hardware Driver Interface", "build_guide.html#dep_uhd", null ],
        [ "gr-video-sdl: PAL and NTSC display", "build_guide.html#dep_gr_video_sdl", null ],
        [ "gr-comedi: Comedi hardware interface", "build_guide.html#dep_gr_comedi", null ],
        [ "gr-log: Logging Tools (Optional)", "build_guide.html#dep_gr_log", null ]
      ] ],
      [ "Building GNU Radio", "build_guide.html#build_gr_cmake", [
        [ "Options", "build_guide.html#Cmake", null ],
        [ "Building for the E100", "build_guide.html#build_gr_cmake_e100", null ]
      ] ]
    ] ],
    [ "Instructions for using VOLK in GNU Radio", "volk_guide.html", [
      [ "Introduction", "volk_guide.html#volk_intro", null ],
      [ "Setting and Using Memory Alignment Information", "volk_guide.html#volk_alignment", null ],
      [ "Calling VOLK kernels in Work()", "volk_guide.html#volk_work", null ],
      [ "Tuning VOLK Performance", "volk_guide.html#volk_tuning", [
        [ "Hand-Tuning Performance", "volk_guide.html#volk_hand_tuning", null ]
      ] ]
    ] ],
    [ "Logging", "page_logger.html", [
      [ "Logging", "page_logger.html#logging", [
        [ "Logging Configuration", "page_logger.html#configfile", null ],
        [ "Advanced Configuration Options", "page_logger.html#adv_config", null ]
      ] ],
      [ "Advanced Usage", "page_logger.html#advlog", null ],
      [ "Logging from Python", "page_logger.html#logPy", null ]
    ] ],
    [ "Metadata Information", "page_metadata.html", [
      [ "Structure", "page_metadata.html#structure", [
        [ "Types of Metadata Files", "page_metadata.html#types", null ],
        [ "Updating Headers", "page_metadata.html#updating", null ],
        [ "Implementation", "page_metadata.html#implementation", null ],
        [ "Header Information", "page_metadata.html#header", null ],
        [ "Extras Information", "page_metadata.html#extras", null ]
      ] ],
      [ "Utilities", "page_metadata.html#Utilities", null ],
      [ "Examples", "page_metadata.html#Examples", null ]
    ] ],
    [ "Message Passing", "page_msg_passing.html", [
      [ "Introduction", "page_msg_passing.html#intro", null ],
      [ "Message Passing API", "page_msg_passing.html#api", [
        [ "Message Handler Functions", "page_msg_passing.html#msg_handler", null ],
        [ "Connecting Messages through the Flowgraph", "page_msg_passing.html#msg_fg_connect", null ]
      ] ],
      [ "Code Examples", "page_msg_passing.html#examples", null ],
      [ "Posting from External Sources", "page_msg_passing.html#posting", null ]
    ] ],
    [ "OFDM", "page_ofdm.html", [
      [ "Conventions and Notations", "page_ofdm.html#conventions", [
        [ "FFT Shifting", "page_ofdm.html#fftshift", null ],
        [ "Carrier Indexing", "page_ofdm.html#indexing", null ],
        [ "Carrier and Symbol Allocation", "page_ofdm.html#carrieralloc", null ]
      ] ],
      [ "Detection and Synchronisation", "page_ofdm.html#detectsync", null ],
      [ "Transmitting", "page_ofdm.html#tx", null ],
      [ "Receiving", "page_ofdm.html#rx", null ]
    ] ],
    [ "Packet Data Transmission", "page_packet_data.html", [
      [ "Structure of a packet", "page_packet_data.html#packetstructure", null ],
      [ "The Header/Payload Demuxer and header parser", "page_packet_data.html#hpdemuxer", null ],
      [ "Packet receiver example: OFDM", "page_packet_data.html#ofdm", null ]
    ] ],
    [ "Performance Counters", "page_perf_counters.html", [
      [ "Compile-time and Run-time Configuration", "page_perf_counters.html#pc_config", [
        [ "Compile-time Config", "page_perf_counters.html#pc_config_compile", null ],
        [ "Run-time Config", "page_perf_counters.html#pc_config_runtime", null ]
      ] ],
      [ "Performance Monitor", "page_perf_counters.html#pc_perfmonitor", null ]
    ] ],
    [ "Polyphase Filterbanks", "page_pfb.html", [
      [ "Usage", "page_pfb.html#Usage", null ],
      [ "The PFB Arbitrary Resampler Kernel", "page_pfb.html#pfb_arb_resampl", null ]
    ] ],
    [ "Polymorphic Types", "page_pmt.html", [
      [ "PMT Data Type", "page_pmt.html#datatype", null ],
      [ "Inserting and Extracting Data", "page_pmt.html#insert", null ],
      [ "Strings", "page_pmt.html#strings", null ],
      [ "Tests and Comparisons", "page_pmt.html#tests", null ],
      [ "Dictionaries", "page_pmt.html#dict", null ],
      [ "Vectors", "page_pmt.html#vectors", [
        [ "BLOB", "page_pmt.html#blob", null ]
      ] ],
      [ "Pairs", "page_pmt.html#pairs", null ],
      [ "Serializing and Deserializing", "page_pmt.html#serdes", null ],
      [ "Printing", "page_pmt.html#printing", null ]
    ] ],
    [ "Stream Tags", "page_stream_tags.html", [
      [ "API Extensions to the gr::block", "page_stream_tags.html#block_api_extensions", null ],
      [ "Stream Tags API", "page_stream_tags.html#stream_tags_api", [
        [ "Adding a Tag to a Stream", "page_stream_tags.html#add_item_tag", null ],
        [ "Getting tags from a Stream", "page_stream_tags.html#get_item_tags", null ]
      ] ],
      [ "Tag Propagation", "page_stream_tags.html#tag_propagation", [
        [ "Tag Propagation through Rate Changes", "page_stream_tags.html#tags_rate_changes", null ]
      ] ],
      [ "Notes on How to Use Tags", "page_stream_tags.html#tags_issues", null ]
    ] ],
    [ "Tagged Stream Blocks", "page_tagged_stream_blocks.html", [
      [ "Creating a tagged stream block", "page_tagged_stream_blocks.html#creating", [
        [ "How do they work?", "page_tagged_stream_blocks.html#howtheywork", null ],
        [ "How do they relate to other block types (e.g. sync blocks)?", "page_tagged_stream_blocks.html#relatestootherblocks", null ],
        [ "A note on tag propagation", "page_tagged_stream_blocks.html#note_on_tp", null ]
      ] ],
      [ "Connecting regular streaming blocks and tagged stream blocks", "page_tagged_stream_blocks.html#connecting", null ],
      [ "Advanced Usage", "page_tagged_stream_blocks.html#adv_usage", [
        [ "Multiple length tags", "page_tagged_stream_blocks.html#multiplelentags", null ],
        [ "Falling back to gr::block behaviour", "page_tagged_stream_blocks.html#backtogrblock", null ],
        [ "Other ways to determine the number of input items", "page_tagged_stream_blocks.html#otherwaysdetermineninput", null ],
        [ "CRC32", "page_tagged_stream_blocks.html#CRC32", null ],
        [ "OFDM Frame Equalizer", "page_tagged_stream_blocks.html#ofdmeq", null ],
        [ "Tagged Stream Muxer", "page_tagged_stream_blocks.html#muxer", null ],
        [ "Cyclic Prefixer (OFDM)", "page_tagged_stream_blocks.html#ofdmprefixer", null ]
      ] ],
      [ "Troubleshooting", "page_tagged_stream_blocks.html#troubleshooting", null ]
    ] ],
    [ "Block Thread Affinity and Priority", "page_affinity.html", [
      [ "Block Thread Affinity", "page_affinity.html#affinity", [
        [ "GNU Radio Block API", "page_affinity.html#affinity_api", null ],
        [ "Setting Affinity for a gr::hier_block2", "page_affinity.html#affinity_api_hier", null ],
        [ "GRC Access", "page_affinity.html#affinity_api_grc", null ]
      ] ],
      [ "Setting Thread Priority", "page_affinity.html#priority_api", null ]
    ] ],
    [ "Exploring GNU Radio", "page_exploring_gnuradio.html", [
      [ "Dial Tone Example", "page_exploring_gnuradio.html#ex_dial_tone", null ],
      [ "FM Demodulator", "page_exploring_gnuradio.html#ex_fm_demod", [
        [ "Modulator", "page_exploring_gnuradio.html#Modulator", null ],
        [ "Demodulator", "page_exploring_gnuradio.html#Demodulator", null ]
      ] ]
    ] ],
    [ "Analog Modulation", "page_analog.html", null ],
    [ "Audio Interface", "page_audio.html", null ],
    [ "Standard GNU Radio Blocks", "page_blocks.html", null ],
    [ "Channel Model Blocks", "page_channels.html", [
      [ "Available Channel Models", "page_channels.html#channels_types", [
        [ "AWGN Channel", "page_channels.html#channels_awgn", null ],
        [ "Fading Channel Model", "page_channels.html#channels_fading", null ],
        [ "Frequency-Selective Fading Model", "page_channels.html#channels_selective_fading", null ],
        [ "Hardware Impairments Model", "page_channels.html#channels_hw_impairments", null ]
      ] ]
    ] ],
    [ "Digital Modulation", "page_digital.html", [
      [ "Constellation Objects", "page_digital.html#digital_constellations", [
        [ "Constellation Objects in GRC", "page_digital.html#grc_constellations", null ]
      ] ],
      [ "Python Constellation Helper Functions", "page_digital.html#digital_python_helpers", [
        [ "PSK Python Helpers", "page_digital.html#digital_python_helpers_psk", null ],
        [ "QAM Python Helpers", "page_digital.html#digital_python_helpers_qam", null ]
      ] ],
      [ "The Generic Modulator/Demodulator", "page_digital.html#digital_generic_mod_demod", [
        [ "Generic Modulator", "page_digital.html#digital_generic_mod", null ],
        [ "Generic Demodulator", "page_digital.html#digital_generic_demod", null ],
        [ "Guts of the Modulator and Demodulator", "page_digital.html#digital_generic_guts", null ]
      ] ],
      [ "Support for Soft Decisions", "page_digital.html#digital_softbits", [
        [ "Review of the Soft Decision API/Functions", "page_digital.html#soft_dec_api", null ]
      ] ]
    ] ],
    [ "FunCube Dongle Source", "page_fcd.html", null ],
    [ "Forward Error Correction", "page_fec.html", null ],
    [ "FFT Signal Processing Blocks", "page_fft.html", null ],
    [ "Filter Signal Processing Blocks", "page_filter.html", null ],
    [ "QT Graphical User Interface", "page_qtgui.html", [
      [ "Drop-Down Menu and Interacting with Plots", "page_qtgui.html#qtgui_menu", [
        [ "Kernels", "page_filter.html#filter_kernels", null ],
        [ "Blocks", "page_filter.html#filter_blocks", null ],
        [ "Design Tools", "page_filter.html#filter_design_tools", null ],
        [ "Filter Design GUI Tool", "page_filter.html#filter_design", null ],
        [ "Blocks", "page_qtgui.html#Blocks", null ],
        [ "Triggering Menu for Time Plots", "page_qtgui.html#qtgui_menu_trigger", null ]
      ] ],
      [ "Configuration", "page_qtgui.html#Configuration", null ]
    ] ],
    [ "UHD Interface", "page_uhd.html", [
      [ "Documentation", "page_uhd.html#External", null ],
      [ "Setup", "page_uhd.html#Typical", null ]
    ] ],
    [ "Voice Coders and Decoders (Vocoders)", "page_vocoder.html", [
      [ "Using the vocoders", "page_vocoder.html#using_vocoders", null ]
    ] ],
    [ "Modules", "modules.html", "modules" ],
    [ "Namespaces", null, [
      [ "Namespace List", "namespaces.html", "namespaces" ],
      [ "Namespace Members", "namespacemembers.html", [
        [ "All", "namespacemembers.html", "namespacemembers_dup" ],
        [ "Functions", "namespacemembers_func.html", "namespacemembers_func" ],
        [ "Variables", "namespacemembers_vars.html", null ],
        [ "Typedefs", "namespacemembers_type.html", null ],
        [ "Enumerations", "namespacemembers_enum.html", null ],
        [ "Enumerator", "namespacemembers_eval.html", null ]
      ] ]
    ] ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", "functions_dup" ],
        [ "Functions", "functions_func.html", "functions_func" ],
        [ "Variables", "functions_vars.html", "functions_vars" ],
        [ "Typedefs", "functions_type.html", "functions_type" ],
        [ "Enumerations", "functions_enum.html", null ],
        [ "Enumerator", "functions_eval.html", null ],
        [ "Related Functions", "functions_rela.html", null ]
      ] ]
    ] ],
    [ "Files", null, [
      [ "File List", "files.html", "files" ],
      [ "File Members", "globals.html", [
        [ "All", "globals.html", "globals_dup" ],
        [ "Functions", "globals_func.html", "globals_func" ],
        [ "Variables", "globals_vars.html", "globals_vars" ],
        [ "Typedefs", "globals_type.html", null ],
        [ "Enumerations", "globals_enum.html", null ],
        [ "Enumerator", "globals_eval.html", null ],
        [ "Macros", "globals_defs.html", "globals_defs" ]
      ] ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
"ConstellationDisplayPlot_8h.html",
"classConstellationDisplayPlot.html#a224f0268d5d813e11d1365eee586d4fc",
"classDisplayPlot.html#afccdfb8f8817226a785b648c13270e28",
"classGrAtscFieldSyncCorrelator.html#a8292db51645d6d09092c6de44075b65e",
"classPopupMenu.html#a6836a96276e4659c33c8c3386ec61b36",
"classTriggerChannelMenu.html#acc78c4a0f47c1563518aead3115d68a9",
"classatsc__viterbi__decoder.html",
"classgr_1_1analog_1_1agc__ff.html#aa9288b4b090d05609b6ac1b7e1fb0676",
"classgr_1_1analog_1_1simple__squelch__cc.html#a65cee6186627895b307acd665d56d9cc",
"classgr_1_1block__detail.html#af523139ff3db8105cf5f81d206d972ef",
"classgr_1_1blocks_1_1file__meta__sink.html#a3fead78c1a575098b25e00176691c2c2",
"classgr_1_1blocks_1_1short__to__float.html#a43662ee18344fe351aa9b12fa57ec363",
"classgr_1_1channels_1_1dynamic__channel__model.html#ae99035f6dad941c746d6ea7271ad6ffb",
"classgr_1_1digital_1_1fll__band__edge__cc.html#ae033602e41f51c075b1a2d9ad923783a",
"classgr_1_1digital_1_1pfb__clock__sync__ccf.html#ab865be9d7421509eb6afa8821b80eb38",
"classgr_1_1fft_1_1window.html#ab4c09f31b32b3067f82aefb79a6194d4",
"classgr_1_1filter_1_1kernel_1_1iir__filter.html#a4363ff21e735805cba8d74331d6bed21",
"classgr_1_1hier__block2.html",
"classgr_1_1py__feval__cc.html",
"classgr_1_1qtgui_1_1histogram__sink__f.html#ad939536338de8d036182f345e7b5cd8c",
"classgr_1_1qtgui_1_1time__sink__c.html#ad4106a24d5912a39e6ef8ebc2266d8a0",
"classgr_1_1tagged__stream__block.html#a6ce6d685bfe6e4ebfe04df9d6a222cbe",
"classgr_1_1vocoder_1_1cvsd__decode__bs.html#ae2d963afa522ce524f936fcb6dd4250b",
"classrpcbasic__inserter_3_01T_00_01std_1_1vector_3_01float_01_4_01_4.html",
"crc32_8h.html#ga3e524c0cd3cf5e9f3697c5489f4e2278",
"fsm_8h.html",
"gnuradio-runtime_2include_2gnuradio_2types_8h.html#acd3f499576e769966ea44554b359d949",
"high__res__timer_8h.html#a929f45f159af9ecb21c42e9c3addc622",
"lfsr_8h.html",
"namespacemembers.html",
"page_tagged_stream_blocks.html#muxer",
"pmt_8h.html#ab398394f8e23351c66b28d5b6229c9cf",
"rpcserver__selector_8h_source.html",
"structVOLK__CPU.html#ab04faacf81e00ff2115aeb55e778ca7e",
"structvolk__machine.html#a339490a847d1d1b42abb213c8b614dcb",
"structvolk__machine.html#aae7ce2c494fe72f1e6e7a484b02e4b3f",
"timedisplayform_8h_source.html",
"volk_8h.html#a4eb37fa8042f31ab0aaa63c83969373f",
"volk_8h.html#ae12be371976e553715f85b5023c7e606",
"volk__64u__byteswap_8h_source.html"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function hashValue()
{
  return $(location).attr('hash').substring(1).replace(/[^\w\-]/g,'');
}

function hashUrl()
{
  return '#'+hashValue();
}

function pathName()
{
  return $(location).attr('pathname').replace(/[^-A-Za-z0-9+&@#/%?=~_|!:,.;\(\)]/g, '');
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  }
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  if (node.childrenData) {
    var imgNode = document.createElement("img");
    imgNode.style.paddingLeft=(16*level).toString()+'px';
    imgNode.width  = 16;
    imgNode.height = 22;
    imgNode.border = 0;
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    var span = document.createElement("span");
    span.style.display = 'inline-block';
    span.style.width   = 16*(level+1)+'px';
    span.style.height  = '22px';
    span.innerHTML = '&#160;';
    domNode.appendChild(span);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  var ancParent = $(anchor.parent());
  if (ancParent.hasClass('memItemLeft') ||
      ancParent.hasClass('fieldname') ||
      ancParent.hasClass('fieldtype') ||
      ancParent.is(':header'))
  {
    pos = ancParent.position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath(pathName());
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = hashUrl();
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+hashValue()+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parent().attr('class')=='fieldname'){
    glowEffect(anchor.parent().parent(),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath(pathName())+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).css({'display':'block'});
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function removeToInsertLater(element) {
  var parentNode = element.parentNode;
  var nextSibling = element.nextSibling;
  parentNode.removeChild(element);
  return function() {
    if (nextSibling) {
      parentNode.insertBefore(element, nextSibling);
    } else {
      parentNode.appendChild(element);
    }
  };
}

function getNode(o, po)
{
  var insertFunction = removeToInsertLater(po.li);
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
  insertFunction();
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1].replace(/[^\w\-]/g,'');
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2(pathName())+hashUrl());
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  $(window).load(function(){
    navTo(o,toroot,hashUrl(),relpath);
    showRoot();
  });

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath(pathName())+':'+hashValue();
         a=$('.item a[class$="'+clslink.replace(/</g,'\\3c ')+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2(pathName());
       navTo(o,link,hashUrl(),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,hashUrl(),relpath);
     }
  })
}

